/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2001-2008 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: prc_sil.h 593 2007-11-12 05:36:01Z honda $
 */

/*
 *  sil.h̃vZbTˑiSH12Apj
 */

#ifndef TOPPERS_PRC_SIL_H
#define TOPPERS_PRC_SIL_H

#ifndef TOPPERS_MACRO_ONLY

#include <machine.h>	/*  n̑gݍ݊֐  */

/*
 *  ˑ̃CC֐
 */
#pragma inline (TOPPERS_disint, TOPPERS_set_iipm)

/*
 *  ˑ̃CC֐
 *  @target_sil.hŃGfBA`ɁA
 *  @̃t@CCN[hB
 */
#pragma inline (sil_reb_mem, sil_wrb_mem)

#pragma inline (sil_reh_mem, sil_wrh_mem)
#ifdef SIL_ENDIAN_BIG			/* rbOGfBAvZbT */
#pragma inline (sil_reh_lem, sil_wrh_lem)
#else /* SIL_ENDIAN_BIG */		/* gGfBAvZbT */
#pragma inline (sil_reh_bem, sil_wrh_bem)
#endif /* SIL_ENDIAN_BIG */

#pragma inline (sil_rew_mem, sil_wrw_mem)
#ifdef SIL_ENDIAN_BIG			/* rbOGfBAvZbT */
#pragma inline (sil_rew_lem, sil_wrw_lem)
#else /* SIL_ENDIAN_BIG */		/* gGfBAvZbT */
#pragma inline (sil_rew_bem, sil_wrw_bem)
#endif /* SIL_ENDIAN_BIG */

/*  SRWX^Irbg  */
#define TOPPERS_SH_SR_I_BIT		0x000000F0U

/*
 *  NMIׂĂ݂̊̋֎~
 */
Inline uint32_t
TOPPERS_disint(void)
{
    uint32_t  TOPPERS_sr, TOPPERS_sr2;
    
    TOPPERS_sr = (uint32_t)get_cr();
    TOPPERS_sr2 = TOPPERS_sr | TOPPERS_SH_SR_I_BIT;
    set_cr((int)TOPPERS_sr2);
    TOPPERS_sr &= TOPPERS_SH_SR_I_BIT;
    return(TOPPERS_sr);
}

/*
 *  ݗDx}XNi\ǰݒl̐ݒ
 */
Inline void
TOPPERS_set_iipm(uint32_t TOPPERS_iipm)
{
    uint32_t  TOPPERS_sr;

    TOPPERS_sr = (uint32_t)get_cr();
    TOPPERS_sr = (TOPPERS_sr & ~TOPPERS_SH_SR_I_BIT) | TOPPERS_iipm;
    set_cr((int)TOPPERS_sr);
}

/*
 *  S݃bNԂ̐
 */
#define SIL_PRE_LOC      uint32_t TOPPERS_iipm
#define SIL_LOC_INT()    ((void)(TOPPERS_iipm = TOPPERS_disint()))
#define SIL_UNL_INT()    (TOPPERS_set_iipm(TOPPERS_iipm))

#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_PRC_SIL_H */
