/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2001-2008 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: sh_scif.c 15 2006-10-30 07:37:23Z honda $
 */

/*
 *   SH SCIFp ȈSIOhCo
 */

#include <sil.h>
#include "target_syssvc.h"
#include "sh_scif.h"

/*
 * SH SCIF̃WX^ݒ
 */

/*
 * eWX^̃ItZbg
 */
#define SCIF_SCSMR   0x0000U  /* H */
#define SCIF_SCBRR   0x0004U  /* B */
#define SCIF_SCSCR   0x0008U  /* H */
#define SCIF_SCFTDR  0x000cU  /* B */
#define SCIF_SCFSR   0x0010U  /* H */
#define SCIF_SCFRDR  0x0014U  /* B */
#define SCIF_SCFCR   0x0018U  /* H */
#define SCIF_SCFDR   0x001cU  /* H */
#define SCIF_SCSPTR  0x0024U  /* H */

/*
 * eWX^̐ݒl
 */
#define SCSMR_CHR    0x0040U
#define SCSMR_PE     0x0020U
#define SCSMR_OE     0x0010U
#define SCSMR_STOP   0x0008U
#define SCSMR_CKS1   0x0002U
#define SCSMR_CKS0   0x0001U

#define SCSCR_TIE    0x0080U
#define SCSCR_RIE    0x0040U
#define SCSCR_TE     0x0020U
#define SCSCR_RE     0x0010U
#define SCSCR_CKE1   0x0002U
#define SCSCR_CKE0   0x0001U

#define SCFSR_ER     0x0080U
#define SCFSR_TEND   0x0040U
#define SCFSR_TDFE   0x0020U
#define SCFSR_BRK    0x0010U
#define SCFSR_FER    0x0008U
#define SCFSR_PER    0x0004U
#define SCFSR_RDF    0x0002U
#define SCFSR_DR     0x0001U

#define SCFCR_RTRG1  0x0080U
#define SCFCR_RTRG0  0x0040U
#define SCFCR_TTRG1  0x0020U
#define SCFCR_TTRG0  0x0010U
#define SCFCR_MCE    0x0008U
#define SCFCR_TFRST  0x0004U
#define SCFCR_RFRST  0x0002U
#define SCFCR_LOOP   0x0001U

#define SCSPTR_RTSIO  0x0080U
#define SCSPTR_RTSDT  0x0040U
#define SCSPTR_CTSIO  0x0020U
#define SCSPTR_CTSDT  0x0010U
#define SCSPTR_SPB2IO 0x0002U
#define SCSPTR_SPB2DT 0x0001U

/*
 *  VAI/O|[gubN̒`
 */
typedef struct sio_port_initialization_block {
    void  *scsmr_h;   /* VA[hWX^ */
    void  *scbrr_b;   /* rbg[gWX^ */
    void  *scscr_h;   /* VARg[WX^ */
    void  *scftdr_b;  /* gX~bgFIFOf[^WX^ */
    void  *scfsr_h;   /* VAXe[^XWX^ */
    void  *scfrdr_b;  /* V[uFIFOf[^WX^ */
    void  *scfcr_h;   /* FIFORg[WX^ */
    void  *scfdr_h;   /* V[uFIFOf[^WX^ */
    void  *scsptr_h;  /* VA|[gWX^ */
    uint8_t bps_setting; /* {[[g̐ݒl */
    INTNO intno_rx;  /* Mݔԍ   */
    INTNO intno_tx;  /* Mݔԍ   */
} SIOPINIB;

/*
 *  VAI/O|[gǗubN̒`
 */
struct sio_port_control_block {
    const SIOPINIB  *p_siopinib;  /* VAI/O|[gubN */
    intptr_t  exinf;              /* g */
    bool_t    openflag;           /* I[vς݃tO */
    bool_t    sendflag;           /* M݃Cl[utO */
    bool_t    getready;           /* M */
    bool_t    putready;           /* 𑗐Mł */
    bool_t    is_initialized;     /* foCXς݃tO */
};

/*
 *  VAI/O|[gubN
 */
static const SIOPINIB siopinib_table[TNUM_SIOP] = {
    {
        (void *)(SH_SCIF0_BASE + SCIF_SCSMR),
        (void *)(SH_SCIF0_BASE + SCIF_SCBRR),
        (void *)(SH_SCIF0_BASE + SCIF_SCSCR),
        (void *)(SH_SCIF0_BASE + SCIF_SCFTDR),
        (void *)(SH_SCIF0_BASE + SCIF_SCFSR),
        (void *)(SH_SCIF0_BASE + SCIF_SCFRDR),
        (void *)(SH_SCIF0_BASE + SCIF_SCFCR),
        (void *)(SH_SCIF0_BASE + SCIF_SCFDR),
        (void *)(SH_SCIF0_BASE + SCIF_SCSPTR),
        SCIF0_BPS_SETTING,
        SCIF0_RXI_INTNO,
        SCIF0_TXI_INTNO
    },
#if TNUM_SIOP > 1
    {        
        (void *)(SH_SCIF1_BASE + SCIF_SCSMR),
        (void *)(SH_SCIF1_BASE + SCIF_SCBRR),
        (void *)(SH_SCIF1_BASE + SCIF_SCSCR),
        (void *)(SH_SCIF1_BASE + SCIF_SCFTDR),
        (void *)(SH_SCIF1_BASE + SCIF_SCFSR),
        (void *)(SH_SCIF1_BASE + SCIF_SCFRDR),
        (void *)(SH_SCIF1_BASE + SCIF_SCFCR),
        (void *)(SH_SCIF1_BASE + SCIF_SCFDR),
        (void *)(SH_SCIF1_BASE + SCIF_SCSPTR),
        SCIF1_BPS_SETTING,
        SCIF1_RXI_INTNO,
        SCIF1_TXI_INTNO
    },
#endif /* TNUM_SIOP > 1 */   
#if TNUM_SIOP > 2
    {
        (void *)(SH_SCIF2_BASE + SCIF_SCSMR),
        (void *)(SH_SCIF2_BASE + SCIF_SCBRR),
        (void *)(SH_SCIF2_BASE + SCIF_SCSCR),
        (void *)(SH_SCIF2_BASE + SCIF_SCFTDR),
        (void *)(SH_SCIF2_BASE + SCIF_SCFSR),
        (void *)(SH_SCIF2_BASE + SCIF_SCFRDR),
        (void *)(SH_SCIF2_BASE + SCIF_SCFCR),
        (void *)(SH_SCIF2_BASE + SCIF_SCFDR),
        (void *)(SH_SCIF2_BASE + SCIF_SCSPTR),
        SCIF2_BPS_SETTING,
        SCIF2_RXI_INTNO,
        SCIF2_TXI_INTNO
    }
#endif /* TNUM_SIOP > 2 */
};


/*
 *  VAI/O|[gǗubÑGA
 */
static SIOPCB	siopcb_table[TNUM_SIOP];

/*
 *  VAI/O|[gIDǗubNo߂̃}N
 */
#define INDEX_SIOP(siopid)	 ((uint_t)((siopid) - 1))
#define get_siopcb(siopid)	 (&(siopcb_table[INDEX_SIOP(siopid)]))
#define get_siopinib(siopid) (&(siopinib_table[INDEX_SIOP(siopid)]))

/*
 *  MH
 */
Inline bool_t
sh_scif_getready(SIOPCB *p_siopcb)
{
    return((sil_reh_mem(p_siopcb->p_siopinib->scfsr_h) & SCFSR_RDF) != 0);
}

/*
 *  𑗐Mł邩H
 */
Inline bool_t
sh_scif_putready(SIOPCB *p_siopcb)
{
    return((sil_reh_mem(p_siopcb->p_siopinib->scfsr_h) & SCFSR_TDFE) != 0);
}

/*
 *  M̎o
 */
Inline char_t
sh_scif_getchar(SIOPCB *p_siopcb)
{
    uint8_t c;
    c = sil_reb_mem(p_siopcb->p_siopinib->scfrdr_b);
    sil_wrh_mem(p_siopcb->p_siopinib->scfsr_h,
                (sil_reh_mem(p_siopcb->p_siopinib->scfsr_h) & ~SCFSR_RDF));
    return(c);
}

/*
 *  M镶̏
 */
Inline void
sh_scif_putchar(SIOPCB *p_siopcb, char_t c)
{
    sil_wrb_mem(p_siopcb->p_siopinib->scftdr_b, (uint8_t)c);
    sil_wrh_mem(p_siopcb->p_siopinib->scfsr_h,
                (sil_reh_mem(p_siopcb->p_siopinib->scfsr_h) & ~(SCFSR_TDFE)));
}

/*
 *  M݋
 */
Inline void
sh_scif_enable_send(SIOPCB *p_siopcb)
{
    sil_wrh_mem(p_siopcb->p_siopinib->scscr_h,
                (sil_reh_mem(p_siopcb->p_siopinib->scscr_h) | SCSCR_TIE));
}

/*
 *  M݋֎~
 */
Inline void
sh_scif_disable_send(SIOPCB *p_siopcb)
{
    sil_wrh_mem(p_siopcb->p_siopinib->scscr_h,
                (sil_reh_mem(p_siopcb->p_siopinib->scscr_h) & ~SCSCR_TIE));
}


/*
 *  M݋
 */
Inline void
sh_scif_enable_rcv(SIOPCB *p_siopcb)
{
    sil_wrh_mem(p_siopcb->p_siopinib->scscr_h,
                (sil_reh_mem(p_siopcb->p_siopinib->scscr_h) | SCSCR_RIE));    
}

/*
 *  M݋֎~
 */
Inline void
sh_scif_disable_rcv(SIOPCB *p_siopcb)
{
    sil_wrh_mem(p_siopcb->p_siopinib->scscr_h,
                (sil_reh_mem(p_siopcb->p_siopinib->scscr_h) & ~SCSCR_RIE));    
}

/*
 *  SIOhCȍ
 */
void
sh_scif_initialize(void)
{
	SIOPCB	*p_siopcb;
	uint_t	i;

	/*
	 *  VAI/O|[gǗubN̏
	 */
    for (p_siopcb = siopcb_table, i = 0; i < TNUM_SIOP; p_siopcb++, i++) {
        p_siopcb->p_siopinib = &(siopinib_table[i]);
        p_siopcb->openflag = false;
        p_siopcb->sendflag = false;
    }
}


/*
 * n[hEFȀ
 */
static void
sh_scif_init_siopinib(const SIOPINIB *p_siopinib)
{
    /* UART~ */
	sil_wrh_mem(p_siopinib->scscr_h, 0x00U);    

    /* MMFIFONA */   
	sil_wrh_mem(p_siopinib->scfcr_h, (SCFCR_TFRST|SCFCR_RFRST));

    /*  8f[^,1Xgbvrbg,no parity */
    sil_wrh_mem(p_siopinib->scsmr_h, 0x0000U);

    /*  ^RTS2 ɏo */
    sil_wrh_mem(p_siopinib->scsptr_h, SCSPTR_RTSIO);
   
	/* {[[gݒ */
    sil_wrb_mem(p_siopinib->scbrr_b, p_siopinib->bps_setting);

    /*
     * 1rbg҂Kv
     */
    sil_dly_nse(1000000);
    
    /* Xe[^X̃NA */
    sil_wrh_mem(p_siopinib->scfsr_h,
                sil_reh_mem(p_siopinib->scfsr_h) & ~(SCFSR_TEND|SCFSR_TDFE));
    
    /* gK̐ݒ R-FIFO=1,T-FIFO=1 */
	sil_wrh_mem(p_siopinib->scfcr_h, (SCFCR_TTRG1|SCFCR_TTRG0));

    /* UARTJn */
	sil_wrh_mem(p_siopinib->scscr_h, (SCSCR_TE|SCSCR_RE));   
}


/*
 * J[lÑo[io͗p̏
 */
void
sh_scif_init(ID siopid)
{
    SIOPCB          *p_siopcb   = get_siopcb(siopid);
    const SIOPINIB  *p_siopinib = get_siopinib(siopid);
    /*  ̎_ł́Ap_siopcb->p_siopinib͏ĂȂ  */
    
    /*  d̖h~  */
    p_siopcb->is_initialized = true;

	/*  n[hEFȀ  */
    sh_scif_init_siopinib(p_siopinib);
}

/*
 *  VAI/O|[g̃I[v
 */
SIOPCB *
sh_scif_opn_por(ID siopid, intptr_t exinf)
{
    SIOPCB          *p_siopcb;
    const SIOPINIB  *p_siopinib;
      
    p_siopcb = get_siopcb(siopid);
    p_siopinib = p_siopcb->p_siopinib;

    /*
     * n[hEFȀ     
     * @ɏĂꍇ́AdɏȂB
     */
    if (!(p_siopcb->is_initialized)) {
    	sh_scif_init_siopinib(p_siopinib);
    	p_siopcb->is_initialized = true;
    }

    p_siopcb->exinf = exinf;
    p_siopcb->getready = p_siopcb->putready = false;
    p_siopcb->openflag = true;

    return(p_siopcb);
}

/*
 *  VAI/O|[g̃N[Y
 */
void
sh_scif_cls_por(SIOPCB *p_siopcb)
{
    /*
     * UART~
     */
	sil_wrh_mem(p_siopcb->p_siopinib->scscr_h, 0x00);
    p_siopcb->openflag = false;
   	p_siopcb->is_initialized = false;
}


/*
 *  VAI/O|[gւ̃|[Oł̏o
 */
void
sh_scif_pol_putc(char_t c, ID siopid)
{
    const SIOPINIB *p_siopinib;
    
    p_siopinib = get_siopinib(siopid);
    
    while((sil_reh_mem(p_siopinib->scfsr_h) & SCFSR_TDFE) == 0);
    
    sil_wrb_mem(p_siopinib->scftdr_b, (uint8_t)c);
    sil_wrh_mem(p_siopinib->scfsr_h,
                (sil_reh_mem(p_siopinib->scfsr_h) & ~(SCFSR_TDFE)));
    
}


/*
 *  VAI/O|[gւ̕M
 */
bool_t
sh_scif_snd_chr(SIOPCB *p_siopcb, char_t c)
{
    if (sh_scif_putready(p_siopcb)){
        sh_scif_putchar(p_siopcb, c);
        return(true);
    }
    return(false);
}

/*
 *  VAI/O|[g̕M
 */
int_t
sh_scif_rcv_chr(SIOPCB *p_siopcb)
{
	if (sh_scif_getready(p_siopcb)) {
		return((int_t)sh_scif_getchar(p_siopcb));
	}
	return(-1);
}

/*
 *  VAI/O|[g̃R[obN̋
 */
void
sh_scif_ena_cbr(SIOPCB *p_siopcb, uint_t cbrtn)
{
    switch (cbrtn) {
      case SIO_RDY_SND:
        sh_scif_enable_send(p_siopcb);
        break;
      case SIO_RDY_RCV:
        sh_scif_enable_rcv(p_siopcb);
        break;
    }
}

/*
 *  VAI/O|[g̃R[obN̋֎~
 */
void
sh_scif_dis_cbr(SIOPCB *p_siopcb, uint_t cbrtn)
{
    switch (cbrtn) {
      case SIO_RDY_SND:
        sh_scif_disable_send(p_siopcb);
        break;
      case SIO_RDY_RCV:
        sh_scif_disable_rcv(p_siopcb);
        break;
    }
}

/*
 *  SIO̊݃T[rX[`
 */
void
sh_scif_tx_isr(ID siopid)
{
    SIOPCB	*p_siopcb = get_siopcb(siopid);
    
    if (sh_scif_putready(p_siopcb)) {
        /*
         *  M\R[obN[`ĂяoD
         */
        sh_scif_irdy_snd(p_siopcb->exinf);
    }
}


/*
 *  SIO̊݃T[rX[`
 */
void
sh_scif_rx_isr(ID siopid)
{
    SIOPCB	*p_siopcb = get_siopcb(siopid);
    
    if (sh_scif_getready(p_siopcb)) {
        /*
         *  MʒmR[obN[`ĂяoD
         */
        sh_scif_irdy_rcv(p_siopcb->exinf);
    }
}


/*
 *  |[gԍǗubN̐擪Ԓnւ̕ϊ
 */
SIOPCB *
sh_scif_get_siopcb(ID siopid) {
	SIOPCB *p_siopcb = get_siopcb(siopid);
	return(p_siopcb);
}

/*
 * ǗubN̐擪ԒnMݔԍւ̕ϊ
 */
INTNO 
sh_scif_intno_rx(SIOPCB *p_siopcb) {
	INTNO intno = p_siopcb->p_siopinib->intno_rx;
	return(intno);
}

/*
 * ǗubN̐擪Ԓn瑗Mݔԍւ̕ϊ
 */
INTNO 
sh_scif_intno_tx(SIOPCB *p_siopcb) {
	INTNO intno = p_siopcb->p_siopinib->intno_tx;
	return(intno);
}

