/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel  
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2007-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN    
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: st16c2550.c,v 1.4 2005/11/12 15:00:43 honda Exp $
 */

/*
 *     ST16C2550 p ȈSIOhCo
 */

#include <sil.h>
#include "target_syssvc.h"
#include "st16c2550.h"

/*
 *  R[obN[`̎ʔԍ
 */
#define SIO_RDY_SND	1U		/* M\R[obN */
#define SIO_RDY_RCV	2U		/* MʒmR[obN */

/*
 * eWX^̃ItZbg
 */
#define ST16C_RHR   0x00   /* H  LCR bit7=0 Read  */
#define ST16C_THR   0x00   /* H  LCR bit7=0 Write */
#define ST16C_DLL   0x00   /* H  LCR bit7=1       */
#define ST16C_IER   0x02   /* H  LCR bit7=0       */
#define ST16C_DLM   0x02   /* H  LCR bit7=1       */
#define ST16C_ISR   0x04   /* H  Read  */
#define ST16C_FCR   0x04   /* H  Write */
#define ST16C_LCR   0x06   /* H  */
#define ST16C_MCR   0x08   /* H  */
#define ST16C_LSR   0x0a   /* H  Read */
#define ST16C_MSR   0x0c   /* H  Read */
#define ST16C_SPR   0x0e   /* H  */

#define ISR_TX            0x02       /* M荞ݔ */
#define IER_TX            0x02       /* M荞݋ */
#define ISR_RX            0x01       /* M荞ݔ */
#define IER_RX            0x01       /* M荞݋ */

#define LCR_DL_MODE       0x80       /* Divisor Enable */
#define LCR_VAL           0x03       /* 8bit,1stop,Noparity,No break */
#define FCR_FIFO_DISABLE  0x00

#define LSR_RX_DATA_READY 0x01
#define LSR_TX_EMPTY      0x20

#define MCR_INT_ENABLE    0x08

/*
 *  115200bpsɐݒ
 *  4 = (7372800Hz)/(115200*16)
 */
#define DLM_VAL  0x00
#define DLL_VAL  0x04

/*
 *  VAI/O|[gubN̒`
 */
typedef struct sio_port_initialization_block {
    uint32_t reg_base;    /* WX^̃x[XAhX */
    uint8_t  lcr_val;     /* [hWX^̐ݒl   */
    uint8_t  dlm_val;     /* {[[gʂ̐ݒl   */
    uint8_t  dll_val;     /* {[[gʂ̐ݒl   */
} SIOPINIB;

/*
 *  VAI/O|[gǗubN̒`
 */
struct sio_port_control_block {
    const SIOPINIB  *p_siopinib; /* VAI/O|[gubN */
    intptr_t         exinf;      /* g */
    bool_t             openflag;   /* I[vς݃tO */
    bool_t             sendflag;   /* M݃Cl[utO */
    bool_t             getready;   /* M */
    bool_t             putready;   /* 𑗐Mł */
};


/*
 * VAI/O|[gubN
 */
const SIOPINIB siopinib_table[TNUM_SIOP] = {
    {ST16C_CHB, LCR_VAL, DLM_VAL, DLL_VAL},
#if TNUM_SIOP > 2
    {ST16C_CHA, LCR_VAL, DLM_VAL, DLL_VAL},
#endif /* TNUM_SIOP > 2 */    
};

/*
 *  VAI/O|[gubN̎o
 */
#define INDEX_SIOPINIB(siopid)  ((uint_t)((siopid) - 1))
#define get_siopinib(siopid)  (&(siopinib_table[INDEX_SIOPINIB(siopid)]))

/*
 *  VAI/O|[gǗubÑGA
 */
SIOPCB  siopcb_table[TNUM_SIOP];

/*
 *  VAI/O|[gIDǗubNo߂̃}N
 */
#define INDEX_SIOP(siopid)  ((uint_t)((siopid) - 1))
#define get_siopcb(siopid)  (&(siopcb_table[INDEX_SIOP(siopid)]))

Inline void
st16c_write(uint32_t addr, uint32_t offset, uint8_t val)
{
    sil_wrh_mem((void*)(addr + offset),val);
}

Inline uint8_t
st16c_read(uint32_t addr, uint32_t offset)
{
    return(sil_reh_mem((void*)(addr + offset)));
}

/*
 * M?
 */ 
Inline bool_t
st16c_getready(SIOPCB *p_siopcb)
{
    uint16_t status;

    status = st16c_read(p_siopcb->p_siopinib->reg_base, ST16C_LSR);
    
    return((status & LSR_RX_DATA_READY));
}

/*
 * 𑗐Mł邩?
 */
Inline bool_t
st16c_putready(SIOPCB *p_siopcb)
{
    uint16_t status;

    status = st16c_read(p_siopcb->p_siopinib->reg_base, ST16C_LSR);
    
    return (status & LSR_TX_EMPTY);
}

/*
 *  M̎o
 */
Inline uint8_t
st16c_getchar(SIOPCB *p_siopcb)
{
    return(st16c_read(p_siopcb->p_siopinib->reg_base, ST16C_RHR));
}

/*
 *  M镶̏
 */
Inline void
st16c_putchar(SIOPCB *p_siopcb, uint8_t c)
{
    st16c_write(p_siopcb->p_siopinib->reg_base, ST16C_THR, c);
}

/*
 *  M݋
 */
Inline void
st16c_enable_send(SIOPCB *p_siopcb)
{
    st16c_write(p_siopcb->p_siopinib->reg_base, ST16C_IER,
                (st16c_read(p_siopcb->p_siopinib->reg_base, ST16C_IER) | IER_TX));
}

/*
 *  M݋֎~
 */
Inline void
st16c_disable_send(SIOPCB *p_siopcb)
{
    st16c_write(p_siopcb->p_siopinib->reg_base, ST16C_IER,
                (st16c_read(p_siopcb->p_siopinib->reg_base, ST16C_IER) & ~IER_TX));
                
}

/*
 *  M݋
 */
Inline void
st16c_enable_rcv(SIOPCB *p_siopcb)
{
    st16c_write(p_siopcb->p_siopinib->reg_base, ST16C_IER,
                (st16c_read(p_siopcb->p_siopinib->reg_base, ST16C_IER) | IER_RX));
}

/*
 *  M݋֎~
 */
Inline void
st16c_disable_rcv(SIOPCB *p_siopcb)
{
    st16c_write(p_siopcb->p_siopinib->reg_base, ST16C_IER,
                (st16c_read(p_siopcb->p_siopinib->reg_base, ST16C_IER) & ~IER_RX));
                
}

/*
 *  SIOhCȍ[`
 */
void
st16c2550_initialize()
{
    SIOPCB  *p_siopcb;
    uint_t  i;

    /*
     *  VAI/O|[gǗubN̏
     */
    for (p_siopcb = siopcb_table, i = 0; i < TNUM_SIOP; p_siopcb++, i++) {
        p_siopcb->p_siopinib = &(siopinib_table[i]);
        p_siopcb->openflag = false;
        p_siopcb->sendflag = false;
    }
    
}

    
/*
 * SIOPINIB̏
 */
void
st16c2550_init_siopinib(const SIOPINIB *p_siopinib)
{
    /*
     *  ̐ݒ
     */
    /* Divisor Enable */
    st16c_write(p_siopinib->reg_base, ST16C_LCR,
                (st16c_read(p_siopinib->reg_base, ST16C_LCR) | LCR_DL_MODE));
    st16c_write(p_siopinib->reg_base, ST16C_DLL, p_siopinib->dll_val);
    st16c_write(p_siopinib->reg_base, ST16C_DLM, p_siopinib->dlm_val);
    /* Divisor Disable */
    st16c_write(p_siopinib->reg_base, ST16C_LCR,
                (st16c_read(p_siopinib->reg_base, ST16C_LCR) & ~LCR_DL_MODE));

    /* [hݒ */
    st16c_write(p_siopinib->reg_base, ST16C_LCR, p_siopinib->lcr_val);

    /* FIFO Disable */
    st16c_write(p_siopinib->reg_base, ST16C_FCR, FCR_FIFO_DISABLE);

    /* ݋֎~ */
    st16c_write(p_siopinib->reg_base, ST16C_IER, 0x00);
}


/*
 *  J[lÑo[i[o͗p̏
 */
void
st16c2550_init(void)
{    
    st16c2550_init_siopinib(get_siopinib(1));
#if TNUM_SIOP > 2
    st16c2550_init_siopinib(get_siopinib(2));    
#endif /* TNUM_SIOP > 2 */        
    
}

/*
 * I[vĂ|[g邩?
 */
bool_t
st16c2550_openflag(void)
{
#if TNUM_SIOP < 2
    return(siopcb_table[0].openflag);
#else /* TNUM_SIOP < 2 */
    return(siopcb_table[0].openflag || siopcb_table[1].openflag);
#endif /* TNUM_SIOP < 2 */
}


/*
 * VAI/O|[g̃I[v
 */
SIOPCB *
st16c2550_opn_por(ID siopid, intptr_t exinf)
{
    SIOPCB      *p_siopcb;
    const SIOPINIB  *p_siopinib;

    p_siopcb = get_siopcb(siopid);
    p_siopinib = p_siopcb->p_siopinib;
    
    /*
     * 
     */
    st16c2550_init_siopinib(p_siopcb->p_siopinib);
    
    /* M݋֎~ */
    st16c_enable_rcv(p_siopcb);
    /* M݋֎~ */
    st16c_disable_rcv(p_siopcb);
    
    /* ݐCl[u */
    st16c_write(p_siopcb->p_siopinib->reg_base, ST16C_MCR, MCR_INT_ENABLE);

    p_siopcb->exinf = exinf;
    p_siopcb->getready = p_siopcb->putready = false;
    p_siopcb->openflag = true;

    return(p_siopcb);
}

/*
 *  VAI/O|[g̃N[Y
 */
void
st16c2550_cls_por(SIOPCB *p_siopcb)
{
    /* ݋֎~ */
    st16c_write(p_siopcb->p_siopinib->reg_base, ST16C_IER, 0x00);   
    p_siopcb->openflag = false;
}

/*
 *  VAI/O|[gւ̃|[Oł̏o
 */
void
st16c2550_pol_putc(char_t c, ID siopid)
{
    const SIOPINIB *p_siopinib;
    
    p_siopinib = get_siopinib(siopid);
    
    while((st16c_read(p_siopinib->reg_base, ST16C_LSR) & LSR_TX_EMPTY)
          != LSR_TX_EMPTY);
    st16c_write(p_siopinib->reg_base, ST16C_THR, c);
}

/*
 *  VAI/O|[gւ̕M
 */
bool_t
st16c2550_snd_chr(SIOPCB *p_siopcb, char_t c)
{
    if (st16c_putready(p_siopcb)){
        st16c_putchar(p_siopcb, c);
        return(true);
    }
    return(false);
}

/*
 *  VAI/O|[g̕M
 */
int
st16c2550_rcv_chr(SIOPCB *p_siopcb)
{
    if (st16c_getready(p_siopcb)) {
        return((int)(uint8_t)st16c_getchar(p_siopcb));
    }
    return(-1);
}

/*
 *  VAI/O|[g̃R[obN̋
 */
void
st16c2550_ena_cbr(SIOPCB *p_siopcb, uint_t cbrtn)
{
    switch (cbrtn) {
        case SIO_RDY_SND:
            st16c_enable_send(p_siopcb);
            break;
        case SIO_RDY_RCV:
            st16c_enable_rcv(p_siopcb);
            break;
    }
}

/*
 *  VAI/O|[g̃R[obN̋֎~
 */
void
st16c2550_dis_cbr(SIOPCB *p_siopcb, uint_t cbrtn)
{
    switch (cbrtn) {
        case SIO_RDY_SND:
            st16c_disable_send(p_siopcb);
            break;
        case SIO_RDY_RCV:
            st16c_disable_rcv(p_siopcb);
            break;
    }
}

/*
 *  VAI/O|[gɑ΂銄ݏ
 */
static void
st16c2550_isr_siop(SIOPCB *p_siopcb)
{
    if (st16c_getready(p_siopcb)) {
        /*
         *  MʒmR[obN[`ĂяoD
         */
        st16c2550_irdy_rcv(p_siopcb->exinf);
    }
    if (st16c_putready(p_siopcb)) {
        /*
         *  M\R[obN[`ĂяoD
         */
        st16c2550_irdy_snd(p_siopcb->exinf);
    }
}

/*
 *  SIO̊݃T[rX[`
 */
void
st16c2550_isr(void)
{
    st16c2550_isr_siop(&(siopcb_table[0]));
}
